﻿using System;
using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WmsServiceClient.Properties;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace ThinkGeo.MapSuite.WmsServiceClient
{
    public class MapModel
    {
        public MapModel(WpfMap wpfMap)
        {
            wpfMap.MapUnit = GeographyUnit.DecimalDegree;
            wpfMap.CurrentExtent = new RectangleShape(-87.7672924, 42.0932118, -87.2534475, 41.565133);
            wpfMap.MapTools.Logo.IsEnabled = false;
            wpfMap.MapTools.MouseCoordinate.IsEnabled = true;
            wpfMap.MapTools.MouseCoordinate.Visibility = Visibility.Hidden;
            wpfMap.MapTools.MouseCoordinate.Margin = new Thickness(0, 0, 180, 5);
            wpfMap.MapTools.MouseCoordinate.MouseCoordinateType = MouseCoordinateType.Custom;

            WmsOverlay wmsOverlay = new WmsOverlay(new Uri("http://localhost:52289/WmsHandler.axd"));
            wmsOverlay.Parameters.Add("layers", "WorldMap");
            wmsOverlay.Parameters.Add("styles", "DEFAULT");
            wmsOverlay.Parameters["SRS"] = Resources.EPSG4326;
            wmsOverlay.Parameters["FORMAT"] = "IMAGE/PNG";
            wpfMap.Overlays.Add(wmsOverlay);
        }
    }
}