﻿using System.Collections.Generic;
using System.Runtime.Serialization;
using ThinkGeo.MapSuite.Core;

namespace ThinkGeo.MapSuite.WorldMapPlugins
{
    [DataContract]
    public class SerializableFeature
    {
        private string id;
        private string wkt;
        private Feature feature;
        private Dictionary<string, string> columnValues;

        public SerializableFeature()
        { }

        [DataMember(Name = "fieldValues")]
        public Dictionary<string, string> ColumnValues
        {
            get
            {
                if (columnValues == null)
                {
                    this.columnValues = new Dictionary<string, string>();
                }
                return this.columnValues;
            }
        }

        [DataMember(Name = "id")]
        public string Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember(Name = "wkt")]
        public string Wkt
        {
            get { return wkt; }
            set
            {
                wkt = value;
                feature = new Feature(wkt);
                foreach (var fieldValue in ColumnValues)
                {
                    feature.ColumnValues.Add(fieldValue.Key, fieldValue.Value);
                }
            }
        }

        public Feature RealFeature
        {
            get { return feature; }
            set { feature = value; }
        }
    }
}
